SCC1	= $0013
SCC2	= $0014
SCC3	= $0015
SCS1	= $0016
SCS2	= $0017
SCDR	= $0018
SCBR	= $0019
CONFIG2	= $001e
CONFIG1	= $001f

FLASH	= $8000
VECTORS	= $fffe


			.area text
;			.org FLASH (specify this using linker options)


entry::		ldhx #$0100					; init Stack Pointer
			txs
			jsr  __HC08Setup
			jsr  _main
done:		bra  done					; endless loop

;-----------------------------------------------------------------------------

__HC08Setup:
			mov  #$01,CONFIG1			; disable Watchdog
			mov  #$01,CONFIG2			; select proper Clock Source for SCI
			rts

;-----------------------------------------------------------------------------

; void initSCI();
;
_initSCI::	mov  #$40,SCC1				; Enable SCI
			mov  #$0c,SCC2				; RE+TE
			;
			; Baudrate Calculation for 4.9152 MHz XTAL
			;-----------------------------------------------
			; BaudRate = ClockSource / (64 * Divisor)
			; if ClockSource = BusClock = XTAL/4
			; (set SCIBDSCR Bit in OPTION2!) then
			; BaudRate = 4.9152 MHz / (4 * 64 * SCP * SCR)
			; BaudRate = 19200 Baud / (SCP * SCR)
			;-----------------------------------------------
			; Rem: in Monitor Mode BusClock = XTAL/2!
			;
			mov  #$00,SCBR				; 19200 Baud
			rts

;-----------------------------------------------------------------------------

; putSCI(char c);
;
_putSCI::	brclr #7,*SCS1,_putSCI		; check SCTE flag
			sta  SCDR
			rts

; char getSCI();
;
_getSCI::	brclr #5,*SCS1,_getSCI		; check SCRF flag
			lda  SCDR
			rts

_putchar	= _putSCI
_getchar	= _getSCI

;-----------------------------------------------------------------------------

; void puts(char *s);
;
_puts::		psha
			;
			; load HX with integer argument from stack
			;
			ldx  4,sp
			pshx
			ldx  6,sp
			pulh
			;
putsloop:	lda  ,x
			beq  putsexit
			jsr  _putchar
			aix  #1
			bra  putsloop
putsexit:	pula
			rts

;-----------------------------------------------------------------------------

_main::		jsr  _initSCI
			;
			clrh
			clrx
delay1:		aix  #-1
			cphx #0
			bne  delay1
			;
mainloop:	ldhx #message
			pshx
			pshh
			jsr  _puts
			ais  #2
			jsr  _getchar
			bra  mainloop
			rts

;-----------------------------------------------------------------------------

message:	.ascii "\r\n\r\n"
			.ascii "HC08 Welcome Kit\r\n"
			.ascii "http://elektronikladen.de/kit08.html\r\n"
			.byte  0

;-----------------------------------------------------------------------------
			.area memory(abs)
			.org VECTORS

			.word entry
;-----------------------------------------------------------------------------

